<?php
/**
 * Article title slider
 *
 * @package 	Article title slider
 * @subpackage 	Article title slider
 * @version   	3.4
 * @author    	Gopi Ramasamy
 * @copyright 	Copyright (C) 2010 - 2015 www.gopiplus.com, LLC
 * @license   	http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
 *
 * http://www.gopiplus.com/extensions/2012/04/article-title-slider-joomla-module/
 */

// no direct access
defined('_JEXEC') or die;

class modArticleSlider
{
	public static function loadScripts(&$params)
	{
		$doc = JFactory::getDocument();
		$ats_jquery = $params->get("ats_jquery","yes");	
		if($ats_jquery == "yes")	
		{
			$doc->addScript(JURI::Root(true).'/modules/mod_article_title_slider/js/jquery.min.js');
		}
		$doc->addScript(JURI::Root(true).'/modules/mod_article_title_slider/js/jquery.cycle.all.min.js');
		$doc->addStyleSheet(JURI::Root(true).'/modules/mod_article_title_slider/css/mod_article_title_slider.css');
	}
	
	public static function getArticleList(&$params)
	{
      	$db			= JFactory::getDBO();
		$user		= JFactory::getUser();
		$userId		= (int) $user->get('id');
		
		$option		= JRequest::getCmd('option');
		$view		= JRequest::getCmd('view');
		
		$temp		= JRequest::getString('id');
		$temp		= explode(':', $temp);
		$id			= $temp[0];
		
		$ats_count 		= (int) $params->get('ats_count', 5);
		$ats_ordering 	= $params->get('ats_ordering');
		$ats_user_id 	= $params->get('ats_user_id', 0);
		$ats_show_front = $params->get('ats_show_front', 1);
		$ats_recent 	= $params->get('ats_recent');
		$ats_cat 		= $params->get('ats_cat', 1);
		$ats_only		= $params->get('ats_only', 0);
		$ats_sccart		= $params->get('ats_show_child_category_articles', 0);
		$ats_levels 	= $params->get('ats_levels', 0); 
		$ats_catexc		= $params->get('ats_catexc', '');
		$current		= 1;

		$access 	= !JComponentHelper::getParams('com_content')->get('show_noauth');
		$authorised = JAccess::getAuthorisedViewLevels(JFactory::getUser()->get('id'));
		
		$app = JFactory::getApplication();
		
		$concats = ' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug,' .
			' CASE WHEN CHAR_LENGTH(cc.alias) THEN CONCAT_WS(":", cc.id, cc.alias) ELSE cc.id END as catslug';
			
		$nullDate = $db->getNullDate();

		$date = JFactory::getDate();
		$now = $date->toSql();
		
		$where		= 'a.state = 1'
			. ' AND ( a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).' )'
			. ' AND ( a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).' )'
			;
		
		if ( $ats_recent ) :
			$where .= ' AND DATEDIFF('.$db->Quote($now).', a.created) < ' . $ats_recent;
		endif;
		
		if ($app->getLanguageFilter()) 
		{
			$where .= ' AND a.language in ('.$db->quote(JFactory::getLanguage()->getTag()).','.$db->quote('*').')';
		}

		if ( $ats_user_id > 1 && $userId ) 
		{
			switch ($ats_user_id)
			{
				case '2':
					$where .= ' AND (created_by = ' . (int) $userId . ' OR modified_by = ' . (int) $userId . ')';
					break;
				case '3':
					$where .= ' AND (created_by <> ' . (int) $userId . ' AND modified_by <> ' . (int) $userId . ')';
					break;
			}
		}
		
		switch ($ats_ordering)
		{
			case 'random':
				$ordering		= ' ORDER BY rand()';
				break;
			case 'h_asc':
				$ordering		= ' ORDER BY a.hits ASC';
				break;
			case 'h_dsc':
				$ordering		= ' ORDER BY a.hits DESC';
				break;
			case 'm_dsc':
				$ordering		= ' ORDER BY a.modified DESC, a.created DESC';
				break;
			case 'order':
				$ordering		= ' ORDER BY a.ordering ASC';
				break;
			case 'c_dsc':
			default:
				$ordering		= ' ORDER BY a.created DESC';
				break;
		}
		
		$joins = ' INNER JOIN #__categories AS cc ON cc.id = a.catid';
		
		switch ( $ats_show_front )
		{
			case 1:
				$joins .= ' LEFT JOIN #__content_frontpage AS f ON f.content_id = a.id';
				$where .= ' AND f.content_id IS NULL';
				break;
			case 2:
				$joins .= ' LEFT JOIN #__content_frontpage AS f ON f.content_id = a.id';
				$where .= ' AND f.content_id = a.id';
				break;
		}
		
        $catid = $the_id = $catCondition = '';
		
		if ( $ats_only == 0 && $option == 'com_content' && $view == 'category' && $ats_cat ==1 ) 
		{
	    	$catid = $id;
		}
				   
        if ( $option == 'com_content' && $view == 'article' && $id ) 
		{
                $the_id = $id;	
				$article = JTable::getInstance('content');
				$article->load( $id );
   
                if ($current == 0) 
				{
                    $where .= ' AND a.id!='.$the_id;
                }
				if ( $ats_cat == 1 )
				{
					$catid = $article->catid;
				}
				
                if ($ats_user_id == 1)
				{
		            $where .= ' AND created_by = ' . $article->created_by;
				}
        }
		if ($catid) 
		{
			$catCondition .= ' AND (cc.id='. $catid;
			if ($ats_sccart && $ats_levels > 0) 
			{
				$categories = JModelLegacy::getInstance('Categories', 'ContentModel', array('ignore_request' => true));
				$categories->setState('params', $app->getParams());
				$levels = $params->get('ats_levels', 1) ? $params->get('ats_levels', 1) : 9999;
				$categories->setState('filter.get_children', $levels);
				$categories->setState('filter.published', 1);
				$categories->setState('filter.access', $access);
				$additional_catids = array();
				$categories->setState('filter.parentId', $catid);
				$recursive = true;
				$items = $categories->getItems($recursive);
	
				if ($items)
				{
					foreach($items as $category)
					{
						$condition = (($category->level - $categories->getParent()->level) <= $levels);
						if ($condition) {
							$catCondition .= ' OR cc.id='. $category->id;
						}
	
					}
				}
			}
			$catCondition .= ')';
		}
		
		if ( !empty($ats_catexc[0]) ) 
		{
                $catCondition .= ' AND (cc.id!=' . implode( ' AND cc.id!=', $ats_catexc ) . ')';
        }
		
		$query = 'SELECT a.*, cc.title AS catname,' .
			$concats  .
			' FROM #__content AS a' .
			$joins  .
			' WHERE '. $where .
			($access ? ' AND a.access IN ('.implode(',', $user->getAuthorisedViewLevels()).')' : '') .
			$catCondition .
			' AND cc.published = 1' .
			$ordering;
			
		$db->setQuery($query, 0, $ats_count);
		$rows = $db->loadObjectList();
		
		$items	= array();
		$i = 0;
		foreach ( $rows as &$row ) 
		{
		    $link = '';
		    $row->title = htmlspecialchars( $row->title );
            if ( $the_id != $row->id or $current != 2 ) 
			{
				$link 				= JRoute::_(ContentHelperRoute::getArticleRoute($row->slug, $row->catslug));
				$items[$i]			= new stdClass;
				$items[$i]->links 	=  $link;
				$items[$i]->title	= $row->title;
				$i++;
			}
		}
      return $items;
    }
}
?>